文章目录
- LeetCode 104.二叉树的最大深度
- 题目链接🔗
- 思路
- LeetCode 111.二叉树的最小深度
- 题目链接🔗
- 思路
- LeetCode 222.完全二叉树的节点个数
- 题目链接🔗
- 普通二叉树求法
- 针对完全二叉树解法
LeetCode 104.二叉树的最大深度
题目链接🔗
LeetCode 104.二叉树的最大深度
思路
本题可以使用前序(中左右),也可以使用后序遍历(左右中),使用前序求的就是深度,使用后序求的是高度。
- 二叉树节点的深度:指从根节点到该节点的最长简单路径边的条数或者节点数(取决于深度从0开始还是从1开始)
- 二叉树节点的高度:指从该节点到叶子节点的最长简单路径边的条数后者节点数(取决于高度从0开始还是从1开始)
而根节点的高度就是二叉树的最大深度,所以本题中我们通过后序求的根节点高度来求的二叉树最大深度。
我先用后序遍历(左右中)来计算树的高度
-
确定递归函数的参数和返回值:参数就是传入树的根节点,返回就返回这棵树的深度,所以返回值为int类型。
int getdepth(TreeNode node)
-
确定终止条件:如果为空节点的话,就返回0,表示高度为0。
if (node == NULL) return 0;
-
确定单层递归的逻辑:先求它的左子树的深度,再求右子树的深度,最后取左右深度最大的数值 再+1 (加1是因为算上当前中间节点)就是目前节点为根节点的树的深度。
int leftdepth = getdepth(node.left); // 左 int rightdepth = getdepth(node.right); // 右 int depth = 1 + max(leftdepth, rightdepth); // 中 return depth;
完整代码为:
public int maxDepth(TreeNode root) {
if (root == null) {
return 0;
}
int leftDepth = maxDepth(root.left);
int rightDepth = maxDepth(root.right);
return Math.max(leftDepth, rightDepth) + 1;
}
class Solution {
/**
* 递归法(求深度法)
*/
//定义最大深度
int maxnum = 0;
public int maxDepth(TreeNode root) {
ans(root,0);
return maxnum;
}
//递归求解最大深度
void ans(TreeNode tr,int tmp){
if(tr==null) return;
tmp++;
maxnum = maxnum<tmp?tmp:maxnum;
ans(tr.left,tmp);
ans(tr.right,tmp);
tmp--;
}
}
题目链接:559.n 叉树的最大深度
class Solution {
public int maxDepth(Node root) {
if(root == null){
return 0;
}
int depth = 0;
if (root.children != null){
for(Node child:root.children){
depth = Math.max(depth, maxDepth(child));
}
}
return depth + 1;
}
}
LeetCode 111.二叉树的最小深度
题目链接🔗
LeetCode 111.二叉树的最小深度
思路
直觉上好像和求最大深度差不多,其实还是差不少的。
本题依然是前序遍历和后序遍历都可以,前序求的是深度,后序求的是高度。
那么使用后序遍历,其实求的是根节点到叶子节点的最小距离,就是求高度的过程,不过这个最小距离 也同样是最小深度。
本题还有一个误区,在处理节点的过程中,最大深度很容易理解,最小深度就不那么好理解,如图:
这就重新审题了,题目中说的是:最小深度是从根节点到最近叶子节点的最短路径上的节点数量,注意是叶子节点。
什么是叶子节点,左右孩子都为空的节点才是叶子节点!
-
确定递归函数的参数和返回值
int getDepth(TreeNode node)
-
确定终止条件
终止条件也是遇到空节点返回0,表示当前节点的高度为0if (node == null) return 0;
-
确定单层递归的逻辑
int leftDepth = getDepth(node.left); // 左 int rightDepth = getDepth(node.right); // 右 // 中 // 当一个左子树为空,右不为空,这时并不是最低点 if (node.left == NULL && node.right != NULL) { return 1 + rightDepth; } // 当一个右子树为空,左不为空,这时并不是最低点 if (node.left != NULL && node.right == NULL) { return 1 + leftDepth; } int result = 1 + min(leftDepth, rightDepth); return result;
整体代码如下:
class Solution {
/**
* 递归法,相比求MaxDepth要复杂点
* 因为最小深度是从根节点到最近**叶子节点**的最短路径上的节点数量
*/
public int minDepth(TreeNode root) {
if (root == null) {
return 0;
}
int leftDepth = minDepth(root.left);
int rightDepth = minDepth(root.right);
if (root.left == null) {
return rightDepth + 1;
}
if (root.right == null) {
return leftDepth + 1;
}
// 左右结点都不为null
return Math.min(leftDepth, rightDepth) + 1;
}
}
LeetCode 222.完全二叉树的节点个数
题目链接🔗
LeetCode 222.完全二叉树的节点个数
本篇给出按照普通二叉树的求法以及利用完全二叉树性质的求法。
普通二叉树求法
递归
-
确定递归函数的参数和返回值:参数就是传入树的根节点,返回就返回以该节点为根节点二叉树的节点数量,所以返回值为int类型。
int getNodesNum(TreeNode cur) {
-
确定终止条件:如果为空节点的话,就返回0,表示节点数为0。
if (cur == null) return 0;
-
确定单层递归的逻辑:先求它的左子树的节点数量,再求右子树的节点数量,最后取总和再加一 (加1是因为算上当前中间节点)就是目前节点为根节点的节点数量。
int leftNum = getNodesNum(cur.left); // 左 int rightNum = getNodesNum(cur.right); // 右 int treeNum = leftNum + rightNum + 1; // 中 return treeNum;
完整代码:
class Solution {
// 通用递归解法
public int countNodes(TreeNode root) {
if(root == null) {
return 0;
}
return countNodes(root.left) + countNodes(root.right) + 1;
}
}
迭代法
class Solution {
public int countNodes(TreeNode root) {
Queue<TreeNode> que = new LinkedList<>();
if(root == null){
return 0;
}
que.offer(root);
int count = 0;
while(!que.isEmpty()){
int len = que.size();
count += len;
while(len > 0){
TreeNode node = que.poll();
if(node.left != null){
que.offer(node.left);
}
if(node.right != null){
que.offer(node.right);
}
len--;
}
}
return count;
}
}
针对完全二叉树解法
完全二叉树只有两种情况,情况一:就是满二叉树,情况二:最后一层叶子节点没有满。
对于情况一,可以直接用 2^树深度 - 1 来计算,注意这里根节点深度为1。
对于情况二,分别递归左孩子,和右孩子,递归到某一深度一定会有左孩子或者右孩子为满二叉树,然后依然可以按照情况1来计算。
完全二叉树(一)如图:
完全二叉树(二)如图:
可以看出如果整个树不是满二叉树,就递归其左右孩子,直到遇到满二叉树为止,用公式计算这个子树(满二叉树)的节点数量。
这里关键在于如何去判断一个左子树或者右子树是不是满二叉树呢?
在完全二叉树中,如果递归向左遍历的深度等于递归向右遍历的深度,那说明就是满二叉树。如图:
在完全二叉树中,如果递归向左遍历的深度不等于递归向右遍历的深度,则说明不是满二叉树,如图:
代码实现:
class Solution {
/**
* 针对完全二叉树的解法
*
* 满二叉树的结点数为:2^depth - 1
*/
public int countNodes(TreeNode root) {
if (root == null) return 0;
TreeNode left = root.left;
TreeNode right = root.right;
int leftDepth = 0, rightDepth = 0; // 这里初始为0是有目的的,为了下面求指数方便
while (left != null) { // 求左子树深度
left = left.left;
leftDepth++;
}
while (right != null) { // 求右子树深度
right = right.right;
rightDepth++;
}
if (leftDepth == rightDepth) {
return (2 << leftDepth) - 1; // 注意(2<<1) 相当于2^2,所以leftDepth初始为0
}
return countNodes(root.left) + countNodes(root.right) + 1;
}
}